var uexDbUtil = {
    'isExists':function(userId, callback){
        var db = uexDbUtil.creatDb();
        if(db == ""){
            callback(false, "打开数据库失败");
            return;
        }
        // 表二名称
        var tableNameTwo = "main_func_two" + userId;
        // 查询当前所有的表名
        var tableIsExit = "select name from sqlite_master where type='table'";
        uexDataBaseMgr.select(db,tableIsExit, function (error,data) {
            if (error) {
                callback(false, "查询表是否存在失败");
                return;
            }
            var isTable2Exits = false;
            // 判断表2是否存在
            for(var i=0, len = data.length; i<len; i++){
                // 如果表2存在
                if(tableNameTwo == data[i].name){
                    isTable2Exits = true;
                    break;
                }
            }
            uexDbUtil.closeDb(db);
            callback(isTable2Exits, "");
        });
    },
    'queryMainDataMy' : function(userId, callback){
        var db = uexDbUtil.creatDb();
        if(db == ""){
            // 查询是错误的
            callback(true, "打开数据库失败");
            return;
        }
        var tableNameTwo = "main_func_two" + userId;
        var sql = "SELECT * FROM " + tableNameTwo + " where position!=0 ORDER BY position ASC";
        uexDataBaseMgr.select(db,sql,function (error,data){
            callback(error,data);
            uexDbUtil.closeDb(db);
        });
    },
    'creatDb' : function(){
        // myMainDb
        var dbName = appcan.locStorage.getVal("PARAMDATAPATH");
        return uexDataBaseMgr.open(dbName);
    },
    'closeDb' : function(db){
        uexDataBaseMgr.close(db);
    },
    'insertMainData':function(userId, arrayMyAll, db, func){
        var sqls = new Array();
        var positionCount = 0;
        var tableNameOne = "main_func_one" + userId;
        var tableNameTwo = "main_func_two" + userId;
        for(var i=0,len=arrayMyAll.length; i<len; i++){
            var sql = "INSERT INTO " + tableNameOne + " (itemId, name) VALUES ("+ arrayMyAll[i].id +", '" + arrayMyAll[i].nav_name + "')";
            sqls.push(sql);
            var contentArray = arrayMyAll[i].children;
            for(var k=0, lenK = contentArray.length; k<lenK; k++){
                // 当前是否是默认的
                var position = 0;
                if(contentArray[k].current){
                    positionCount += 1;
                    position = positionCount;
                }
                var photoUrl = contentArray[k].id + ".png";
                var sqlTwo = "INSERT INTO " + tableNameTwo + " (childId, parentId, iconUrl, name, position) VALUES (" 
                    + contentArray[k].id + ", " + contentArray[k].p_id + ", '" + photoUrl + "', '" 
                    + contentArray[k].nav_name + "', " + position + ")";
                sqls.push(sqlTwo);
            }
        }
        uexDataBaseMgr.transactionEx(db,JSON.stringify(sqls), func);
    },
    'initMainData' : function(userId, allFunc, callback){
        var db = uexDbUtil.creatDb("myMainDb");
        if(db == ""){
            // 查询是错误的
            callback(true, "打开数据库失败");
            return;
        }
        var tableNameOne = "main_func_one" + userId;
        var tableNameTwo = "main_func_two" + userId;
        var createTableSqlOne = "CREATE TABLE " + tableNameOne + " (_id INTEGER PRIMARY KEY,itemId INTEGER,name TEXT)";
        // 创建表1
        uexDataBaseMgr.sql(db,createTableSqlOne, function(error) {
            if(error){
                uexDbUtil.closeDb(db);
                // 是错误的
                callback(true, "创建表1失败");
                return;
            }
            // 创建表2
            var createTableSqlTwo = "CREATE TABLE " + tableNameTwo + " (_id INTEGER PRIMARY KEY,childId INTEGER,parentId INTEGER,iconUrl TEXT,name TEXT,position INTEGER)";
            uexDataBaseMgr.sql(db,createTableSqlTwo, function(error) {
                if(error){
                    uexDbUtil.closeDb(db);
                    // 是错误的
                    callback(true, "创建表2失败");
                    return;
                }
                // 添加数据
                uexDbUtil.insertMainData(userId, allFunc, db, function(error) {
                    if(error){
                        uexDbUtil.closeDb(db);
                        callback(true, "添加数据失败");
                        return;
                    }
                    uexDbUtil.queryMainDataMy(userId, callback);
                });
            });
        });
    },
    'initEditorData' : function(userId, arrayMyAll, callback){
        
        var db = uexDbUtil.creatDb("myMainDb");
        if(db == ""){
            callback(true, "打开数据库失败");
            return;
        }
        // 本地id数组
        var tableOneIds = new Array();
        var tableTwoIds = new Array();
        
        var tableNameOne = "main_func_one" + userId;
        // 获取表1中的id值
        var sql = "SELECT itemId FROM " + tableNameOne;
        uexDataBaseMgr.select(db,sql, function (error,dataOneId) {
            if (error) {
                uexDbUtil.closeDb(db);
                callback(true, "查询表1数据失败");
                return;
            }
            for(var i=0,len=dataOneId.length; i<len; i++){
                tableOneIds.push(parseInt(dataOneId[i].itemId));
            }
            var tableNameTwo = "main_func_two" + userId;
            // 获取表2中的id值
            var sqlTwo = "SELECT childId, position FROM " + tableNameTwo + " ORDER BY position DESC";
            uexDataBaseMgr.select(db,sqlTwo, function (error,dataTwoId) {
                if (error) {
                    uexDbUtil.closeDb(db);
                    callback(true, "查询表2数据失败");
                    return;
                }
                for(var i=0, len=dataTwoId.length; i<len; i++){
                    tableTwoIds.push(parseInt(dataTwoId[i].childId));
                }
                // 网络Id数组
                var netTableOneIds = new Array();
                var netTableTwoIds = new Array();
                var sqls = new Array();
                var positionCount = dataTwoId[0].position;
                for(var i=0,len=arrayMyAll.length; i<len; i++){
                    netTableOneIds.push(parseInt(arrayMyAll[i].id));
                    
                    // 如果本地中不存在这个值
                    if(indexOf(tableOneIds, arrayMyAll[i].id) == -1){
                        var sql = "INSERT INTO " + tableNameOne + " (itemId, name) VALUES ("+ arrayMyAll[i].id +", '" + arrayMyAll[i].nav_name + "')";
                        sqls.push(sql);
                    }
                    var contentArray = arrayMyAll[i].children;
                    for(var k=0, lenK = contentArray.length; k<lenK; k++){
                        netTableTwoIds.push(parseInt(contentArray[k].id));
                        // 如果本地中不存在这个值
                        if(indexOf(tableTwoIds, contentArray[k].id) == -1){
                            // 如果本地中不存在这个值
                            var position = 0;
                            if(contentArray[k].current){
                                positionCount += 1;
                                position = positionCount;
                            }
                            var photoUrl = contentArray[k].id + ".png";
                            var sqlTwo = "INSERT INTO " + tableNameTwo + " (childId, parentId, iconUrl, name, position) VALUES (" 
                                + contentArray[k].id + ", " + contentArray[k].p_id + ", '" + photoUrl + "', '" 
                                + contentArray[k].nav_name + "', " + position + ")";
                            sqls.push(sqlTwo);
                        }
                    }
                }
                // 查看删除的(前面数组中包含后面数组不存在的id)
                var tempOneArray = tableOneIds.minus(netTableOneIds);
                var tempTwoArray = tableTwoIds.minus(netTableTwoIds);
                if(tempOneArray.length > 0){
                    for(var i=0,len=tempOneArray.length; i<len; i++){
                        var sql = "DELETE FROM " + tableNameOne + " WHERE itemId = " + tempOneArray[i];
                        sqls.push(sql);
                    }
                }
                if(tempTwoArray.length > 0){
                    for(var i=0,len=tempTwoArray.length; i<len; i++){
                        var sql = "DELETE FROM " + tableNameTwo + " WHERE childId = " + tempTwoArray[i];
                        sqls.push(sql);
                    }
                }
                if(sqls.length > 0){
                    // 比对完成之后执行
                    uexDataBaseMgr.transactionEx(db,JSON.stringify(sqls), function(error) {
                        if(error){
                            uexDbUtil.closeDb(db);
                            callback(true, "比对执行错误");
                            return;
                        }
                        // 比对完成了查询出值
                        uexDbUtil.queryTwoDataMyFunc(db, tableNameTwo, function(error, dataMy){
                            if(error){
                                uexDbUtil.closeDb(db);
                                callback(true, "比对查询我的功能错误");
                                return;
                            }
                            var localStorage = window.localStorage;
                            localStorage.setItem("MainFirstContentMyFunc", JSON.stringify(dataMy));
                            appcan.window.publish("MainEditor", "");
                            uexDbUtil.queryTwoDataAllFunc(db, userId, function(error, dataAll){
                                if(error){
                                    uexDbUtil.closeDb(db);
                                    callback(true, "比对查询总功能错误");
                                    return;
                                }
                                callback(error, dataMy, dataAll);
                            })
                        })
                    });
                }else {
                    // 不需要比对直接查询出值
                    uexDbUtil.queryTwoDataMyFunc(db, tableNameTwo, function(error, dataMy){
                        if(error){
                            uexDbUtil.closeDb(db);
                            callback(true, "查询我的功能错误");
                            return;
                        }
                        uexDbUtil.queryTwoDataAllFunc(db, userId, function(error, dataAll){
                            if(error){
                                uexDbUtil.closeDb(db);
                                callback(true, "查询总功能错误");
                                return;
                            }
                            callback(error, dataMy, dataAll);
                        })
                    })
                }
            });
            
        });
    },
    'queryTwoDataMyFunc' : function(db, tableName, callBack){
        var sql = "SELECT * FROM " + tableName + " where position!=0 ORDER BY position ASC";
        uexDataBaseMgr.select(db,sql, callBack);
    },
    'queryTwoDataAllFunc' : function(db, userId, callBack){
        var tableNameOne = "main_func_one" + userId;
        var tableNameTwo = "main_func_two" + userId;
        var sql = "SELECT " + tableNameOne + ".itemId, " + tableNameOne + ".name, " + tableNameTwo + ".childId, " + tableNameTwo + ".parentId, " + tableNameTwo + ".iconUrl, " + tableNameTwo + ".name as name1, " + tableNameTwo + ".position FROM " + tableNameOne + ", " + tableNameTwo + " WHERE " + tableNameOne + ".itemId = " + tableNameTwo + ".parentId ORDER BY " + tableNameOne + ".itemId ASC";
        uexDataBaseMgr.select(db,sql, callBack);
    },
    'updateTwoData' : function(userId, arrayMyFun, callback){
        var db = uexDbUtil.creatDb("myMainDb");
        if(db == ""){
            callback(true, "打开数据库失败");
            return;
        }
        var tableNameTwo = "main_func_two" + userId;
        var sqls = new Array();
        sqls.push("UPDATE " + tableNameTwo + " SET position=0");
        for(var i=0, len=arrayMyFun.length; i<len; i++){
            sqls.push("UPDATE " + tableNameTwo + " SET position=" + arrayMyFun[i].position + " WHERE childId=" + arrayMyFun[i].childId + " AND parentId=" + arrayMyFun[i].parentId);
        }
        uexDataBaseMgr.transactionEx(db,JSON.stringify(sqls), callback);
    }
}

/*Array.prototype.contains = function (obj) {
        var i = this.length;
        while (i--) {
            alert("this[i]=" + this[i] + "***" + obj + "***" + (this[i] === obj));
            if (this[i] === obj || this[i] === (obj+"")) {
                return true;
            }
        }
        return false;
    }*/
function indexOf(arr, item) {
    if (Array.prototype.hasOwnProperty("indexOf")) {
        return arr.indexOf(item);
    } else {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == item)
                return i;
            else
                return -1;
        }
    }
}
//2个集合的差集 在arr不存在  
Array.prototype.minus = function (arr) {  
    var result = new Array();  
    var obj = {};  
    for (var i = 0; i < arr.length; i++) {  
        obj[arr[i]] = 1;  
    }  
    for (var j = 0; j < this.length; j++) {  
        if (!obj[this[j]])  
        {  
            obj[this[j]] = 1;  
            result.push(this[j]);  
        }  
    }  
    return result;  
}; 