(function($) {
    appcan.button("#nav-left", "btn-act",
    function() {});
    appcan.button("#nav-right", "btn-act",
    function() {});
    
    // 列表数据组
    var stationArray;

    appcan.ready(function() {
        setList();
        // 选中的位置
        var selectIndex = appcan.locStorage.getVal("mainSelectStationsIndex");
        if(selectIndex == undefined){
            selectIndex = 0;
        }
        $($("#listViewSelectStation").find("li")[selectIndex]).addClass("select-one");
        
        setListenerList(document.getElementById("Page"));
    })
    
    // 获取焦点的时候
    $('#inputStation').focus(function() {
        $("#listViewSelectStation").addClass("uhide");
        $("#listViewInput").removeClass("uhide");
    });
    // 失去焦点的时候
    $("#inputStation").blur(function(){
        if($("#listViewInput").data("index") == 0){
            $("#listViewSelectStation").removeClass("uhide");
            $("#listViewInput").addClass("uhide");
        }
    });
    // 输入值的时候
    $("#inputStation").on('input propertychange', function(event) {
        var _val = $(this).val();
        // 如果全部取消为空的时候
        if(_val == ""){
            var listDataArray = [];
            $("#listViewInput").data("index", 0);
            listViewInput.set(listDataArray);
            return;
        }
        // 设置左侧的选择列表
        var listDataArray = new Array();
        for(var i=0, len=stationArray.length; i<len; i++){
            if(stationArray[i].stationName.indexOf(_val) != -1){
                listDataArray.push({
                    title : '<div class="ulev-m-28">' + stationArray[i].stationName + '</div>',
                    position:i,
                });
            }
        }
        if(listDataArray.length > 0){
            $("#listViewInput").data("index", listDataArray.length);
            listViewInput.set(listDataArray);
            $("#listViewInput").removeClass("uhide");
        }
        // 如果是中文的话，则查询符合的部分显示出来
        /*if(isChinese(_val)){}*/
    });
    
    //检测是否为中文，true表示是中文，false表示非中文
    /*function isChinese(str){
        if(/^[\u3220-\uFA29]+$/.test(str)){
            return true;
        }else{
            return false;
        }
    }*/
    
    var listViewInput = appcan.listview({
      selector : "#listViewInput",
      type : "thinLine",
      hasIcon : false,
      hasAngle : false
    });
    listViewInput.on("click",function(obj,data,subObj){
        var selectIndex = appcan.locStorage.getVal("mainSelectStationsIndex");
        if(selectIndex == data.position){
            // 关闭
            appcan.window.closePopover("MainSelectStation");
            return;
        }
        // 保存下当前选中的位置
        appcan.locStorage.setVal("mainSelectStationsIndex", data.position);
        // 关闭
        appcan.window.evaluateScript({
            name:'Main',
            scriptContent:'changeStation();'
        });
    })
    
    appcan.button(".right-select-layout", "btn-act", function(){
        appcan.window.closePopover("MainSelectStation");
    })

    var listViewSelectStation = appcan.listview({
      selector : "#listViewSelectStation",
      type : "thinLine",
      hasIcon : false,
      hasAngle : false
    });
    listViewSelectStation.on("click",function(obj,data,subObj){
        if(obj.hasClass("select-one")){
            // 关闭
            appcan.window.closePopover("MainSelectStation");
            return;
        }
        // 移除之前的选中边框
        $(".select-one").removeClass("select-one");
        obj.addClass("select-one");
        
        // 保存下当前选中的位置和站点的名称
        appcan.locStorage.setVal("mainSelectStationsIndex", obj.data("index"));
        // 关闭
        appcan.window.evaluateScript({
            name:'Main',
            scriptContent:'changeStation();'
        });
    })
    function setList(){
        var stationArrayStr = appcan.locStorage.getVal("mainSelectStations");
        stationArray = eval('(' + stationArrayStr + ')');
        // 设置左侧的选择列表
        var listDataArray = new Array(stationArray.length);
        for(var i=0, len=stationArray.length; i<len; i++){
            listDataArray[i] = {
                title : '<div class="ulev-m-28">' + stationArray[i].stationName + '</div>',
            };
        }
        listViewSelectStation.set(listDataArray);
    }
})($);


