/**
 * 设置横屏滑动的布局
 * @param {Object} id ListView
 * @param {Object} isVertail true表示Item垂直布局 Item表示水平布局
 * @param {Object} lists 数据
 */
// var touchDiv = document.getElementById("bodd");
var startX;
var startY;
var startT;
var isMove;
var direction;
var initialPos;
var moveLength;
var pageWidth = document.body.clientWidth;
var headerDiv = document.getElementById("Header");
var bodyDiv = document.getElementById("Page");
function setListenerList(touchDiv) {
    touchDiv.addEventListener("touchstart", function(e) {
        var touch = e.touches[0];
        //本次滑动前的初始位置
        startX = touch.pageX;
        startY = touch.pageY;
        initialPos = 0;
        //取消动画效果
        bodyDiv.style.webkitTransition = "";
        //记录手指按下的开始时间
        startT = new Date().getTime();
        isMove = false;
    }, false);

    touchDiv.addEventListener("touchmove", function(e) {
        var touch = e.touches[0];
        var deltaX = touch.pageX - startX;
        var deltaY = touch.pageY - startY;
        // 如果x方向上的位移大于Y方向，则认为是左右滑动，刚开始的1s中如果是向左滑动，则移动；否则，不移动
        if (Math.abs(deltaX) > Math.abs(deltaY) && deltaX < 0 && Math.abs(deltaY) < 8) {
            e.preventDefault();
            moveLength = deltaX;
            var transLeft = initialPos + deltaX;
            //移动页面
            // touchDiv.transform.call($("body"), translate);
            bodyDiv.style.left = transLeft+"px";
            headerDiv.style.left = transLeft+"px";
            isMove = true;
        }
    }, false);

    /*手指离开屏幕时，计算是恢复原位还是关闭页面*/
    touchDiv.addEventListener("touchend", function(e) {
        //e.preventDefault();
        if (isMove) {//发生了左右滑动
            e.preventDefault();
            var deltaT = new Date().getTime() - startT;
            //使用动画过渡让页面滑动到最终的位置
            // touchDiv.style.webkitTransition = "0.3s ease -webkit-transform";
            if (deltaT < 300) {//如果停留时间小于300ms,则认为是快速滑动，无论滑动距离是多少，都关闭页面
                appcan.window.closePopover("MainSelectStation")
            } else {
                //如果滑动距离小于屏幕的50%，则退回到原状态
                if (Math.abs(moveLength) / pageWidth < 0.4) {
                    //bodyDiv.style.left = "translateX(0px)";
                    bodyDiv.style.left = "0px";
                    headerDiv.style.left = "0px";
                } else {
                    //如果滑动距离大于屏幕的50%，则滑动到下一页
                    appcan.window.closePopover("MainSelectStation")
                }
            }
        }
    }, false);
}
