/*global appcan,window */
/*appcan.use("detect", function($, detect) {
 if (detect.os.ios) {
 var viewport = document.getElementsByName("viewport");
 var scale = window.devicePixelRatio ? (1 / window.devicePixelRatio) : 1;
 $("[name='viewport']").attr("content", "width=device-width,target-densitydpi=device-dpi,initial-scale=" + scale + ", minimum-scale=" + scale + ", maximum-scale=" + scale);
 var fontsize = $("body").css("font-size");
 $("body").css("font-size", parseInt(fontsize) * window.devicePixelRatio + "px");
 }
 })*/

appcan.extend(function(app, exports, module) {
    var $ = appcan.require('dom');
    var appWin = appcan.require('window');
    var locStorage = appcan.require('locStorage');
    var view = appcan.require('view');
    /*
     * 兼容pc，移动设备的封装
     * @param String className 要更改的class
     * @param Functon fun 执行结束后的回调
     *
     *
     */
    function isWindows() {
        if (window.navigator.platform == "Win32")
            return true;
        if (!('ontouchstart' in window))
            return true;
    }

    function button(selector, className, fun) {
        $(selector).on(isWindows() ? "mousedown" : "touchstart", function() {
            appcan.touch(className, fun);
        })
    }

    function updateSwitch(obj) {
        var value = obj.attr("data-checked") || 'false';
        value = (value == 'false' ? 'true' : 'false');
        obj.attr("data-checked", value);
        value == 'false' ? obj.addClass("switch-active") : obj.removeClass("switch-active");
        value == 'false' ? obj.removeClass("bc-head") : obj.addClass("bc-head");

    }

    function switchBtn(selector, css, cb) {
        if ( typeof css == 'function') {
            cb = css;
            css = null;
        }
        var obj = $(selector);
        for (var i = 0; i < obj.length; i++) {
            var value = $(obj[i]).attr("data-checked") || 'false';
            value == 'false' ? $(obj[i]).removeClass( css ? css : "bc-head") : $(obj[i]).addClass( css ? css : "bc-head");
        }
        $(selector).on("tap", function(evt) {
            var obj = $(evt.currentTarget);
            var value = obj.attr("data-checked") || 'false';
            value = (value == 'false' ? 'true' : 'false');
            obj.attr("data-checked", value);
            value == 'false' ? obj.removeClass( css ? css : "bc-head") : obj.addClass( css ? css : "bc-head");
            value = value == 'false' ? false : true;
            cb(obj, value);
        })
    }

    function select(sel, cb) {
        $("select",$(sel))[0].selectedIndex = -1;
        var tl = $(sel).find("div[class=text]");
        var sl = $(sel).find('select');
        var op = sl.find('option');
        var index = parseInt(sl.attr('selectedIndex'));
        if (index != -1) {
            tl.html(sl[0].options[index].text);
        }

        $("select", $(sel)).on("change", function(evt) {
            var ele = $(evt.currentTarget);
            appcan.selectChange(evt.currentTarget);
            cb && cb(ele, ele.val());
        });
    }

    function touch(className, fun) {
        var ele = window.event.currentTarget || window.event.srcElement;
        var eventType = window.event.type;
        var hasTouch = ('ontouchstart' in window);
        var $ele = $(ele);
        var ed = $ele.data('inline_event_data');
        if (ed) {
            return;
        }
        ed = {};
        ed.clickFun = $ele.attr('onclick');
        ed.startFun = $ele.attr('ontouchstart') || $ele.attr('onmousedown');
        ed.endFun = $ele.attr('ontouchend') || $ele.attr('onmouseup');
        ed.startClassName = className;
        ed.startCallFun = fun;
        ed.endClassName = ed.startClassName;
        ed.endCallFun = ed.startCallFun;
        $ele.data('inline_event_data', ed);
        $ele.attr('onclick', '');
        $ele.attr('ontouchstart', '');
        $ele.attr('onmousedown', '');
        $ele.attr('ontouchend', '');
        $ele.attr('onmouseup', '');
        if (hasTouch) {
            //set click and change css
            $ele.on('touchstart', function() {
                if (!ed.startClassName) {
                    return;
                }
                $(this).addClass(ed.startClassName);
            });
            $ele.on('touchend', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });
            $ele.on('touchcancel', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });

            $ele.on('tap', function() {
                if (appcan.isFunction(ed.startCallFun)) {
                    ed.startCallFun.apply(this, [].slice.call(arguments));
                }
                var f = new Function(ed.clickFun);
                f();
            });
        } else {
            //just change css
            $ele.on('mousedown', function() {
                if (!ed.startClassName) {
                    return;
                }
                var that = this;
                $(this).addClass(ed.startClassName);
                setTimeout(function() {
                    $(that).removeClass(ed.endClassName);
                }, 300);
            });
            $ele.on('mouseup', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });
            $ele.on('click', function() {
                if (appcan.isFunction(ed.startCallFun)) {
                    ed.startCallFun.apply(this, [].slice.call(arguments));
                }
                var f = new Function(ed.clickFun);
                f();
            });
        }
        //bind webkitTransitionEnd event
        $ele.addClass(ed.startClassName);
        $ele.on('webkitTransitionEnd', function() {

        });
    }

    /*
     * 设置相关check元素选中
     * @param Event e 点击该元素的事件
     * @param Function callback 执行结束后事件回调 todo:同步执行函数没有必要用回调
     *
     *
     */

    function elementFor(e, callback) {
        var forEle;
        e = e || window.event;
        if (e.currentTarget) {
            forEle = e.currentTarget.previousElementSibling;
        } else {
            forEle = e.previousElementSibling;
        }
        var $forEle = $(forEle);
        if ($forEle.prop('tagName') === 'INPUT') {
            if ($forEle.attr('type') === 'checkbox') {
                forEle.checked = !forEle.checked;
                $forEle.trigger("change");
            }
            if ($forEle.attr('type') === 'radio' && !forEle.checked) {
                forEle.checked = 'checked';
                $forEle.trigger("change");
            }
        }
        if (appcan.isFunction(callback)) {
            callback(e, forEle.checked);
        }
    }

    /*
     * 如果是win平太设置body 默认字体
     *
     *
     */

    function initFontsize() {
        var platform = window.navigator.platform;
        if (platform.toLowerCase().indexOf('win') > -1 || platform.toLowerCase().indexOf('wow') > -1 || platform.toLowerCase().indexOf('mac') > -1) {
            var fs = locStorage.getVal('defaultfontsize');
            if (fs) {
                $('body').css('font-size', fs);
            }
        }
    }

    /*
     下拉列表控件
     @param ELE id 下拉列表select标签的对象

     */

    var selectChange = function(sel) {
        var sl = $(sel)[0];
        if (sl) {
            var sp = sl.parentElement;
            //<span>
            if (sp) {
                var ch = sp.getElementsByTagName('div')[0];
                var t = sl.options[sl.selectedIndex].text;
                if (ch) {
                    $(ch).html(t);
                }
            }
        }
    };
    /*
     字符组去除后面空格
     @param Object e event对象
     @param Boolean col 布尔值
     */
    var fold = function(e, col) {
        e = e || window.event;
        var a = e.currentTarget.nextElementSibling;
        if (a.nodeName == 'DIV') {
            var $a = $(a);
            if (col) {
                $a.removeClass('col-c');
            } else {
                $a.addClass('col-c');
            }
        }
    };
    /*
     parseInt
     @param String s 字符串
     */
    var toInt = function(s) {
        return parseInt(s);
    };
    /*
     停止事件的传播
     @param Object t
     */
    var stopPropagation = function(t) {
        if (!t.cancelClick) {
            t.cancelClick = true;
            t.addEventListener('click', function() {
                event.stopPropagation();
            }, true);
        }
    };
    /*
     * 用指定元素的样式打开一个弹框
     * @param String eleId 指定元素的id
     * @param String url 要打开的连接地址
     * @param Int left 距左边的距离
     * @param Int top 距上边的距离
     * @param String name 窗口名称，默认为id
     * @param String
     *
     */
    function openPopoverByEle(eleId, url, left, top, type, name) {
        if (!eleId) {
            return;
        }
        var ele = $('#' + eleId);
        appWin.openPopover({
            name : ( name ? name : eleId),
            url : url,
            left : left,
            top : top,
            width : ele.width(),
            height : ele.height(),
            type : (type || 0)
        });
    }

    /*
     * 简单的模版插件
     *
     *
     */

    var tmpl = function() {
        var config = {
            evaluate : /<%([\s\S]+?)%>/g,
            interpolate : /<%=([\s\S]+?)%>/g,
            escape : /\${([\s\S]+?)}/g
        };
        var args = [].slice.call(arguments);
        args.push(config);
        return view.render.apply(this, args);
    };
    var tmplAppend = function() {
        var config = {
            evaluate : /<%([\s\S]+?)%>/g,
            interpolate : /<%=([\s\S]+?)%>/g,
            escape : /\${([\s\S]+?)}/g
        };
        var args = [].slice.call(arguments);
        args.push(config);
        return view.appendRender.apply(this, args);
    };
    /*
     * 打开一个新窗口
     * @param String name 窗口的名字
     * @param String url 要加载的地址
     * @param Int aniId 动画效果
     * @param int tpye 窗口的类型
     0:普通窗口
     1:OAuth 窗口
     2:加密页面窗口
     4:强制刷新
     8:url用系统浏览器打开
     16:view不透明
     32:隐藏的winwdow
     64:等待popOver加载完毕后显示
     128:支持手势
     256:标记opn的window上一个window不隐藏
     512:标记呗open的浮动窗口用友打开wabapp
     @param animDuration 动画时长
     *
     */

    function openWinWithUrl(name, url, aniId, type, animDuration) {
        if (!name) {
            return;
        }
        appcan.window.open({
            name : name,
            data : url,
            aniId : (aniId || 10),
            type : (type || 0),
            animDuration : (animDuration || 300)
        });
    }

    /*
     * 关闭窗口
     *
     *
     */
    function closeWin(aniId) {
        aniId = aniId || -1;
        appWin.close(aniId);
    }

    /*
     * 设置localstorage的值
     *
     *
     */
    function setLocalVal(key, val) {
        return locStorage.setVal(key, val);
    }

    /*
     * 获取localstorage的值
     *
     *
     */
    function getLocalVal(key) {
        return locStorage.getVal(key);
    }

    /*
     *
     * 在窗口中执行脚本
     *
     *
     *
     */

    function execScriptInWin(name, scriptContent) {
        if (!name || !scriptContent) {
            return;
        }
        appWin.evaluateScript({
            name : name,
            scriptContent : scriptContent
        });
    }

    /*
     * 初始弹动，无回调方法
     */
    function initBounce() {
        appWin.setBounceType('0', 'rgba(255,255,255,0)', 0);
        appWin.setBounceType('1', 'rgba(255,255,255,0)', 0);
    }

    /*
     * 获取当前对象内属性的个数
     *
     */
    function objLength(obj) {
        var c = 0;
        if (!obj) {
            return c;
        }
        if (appcan.isArray(obj)) {
            return obj.length;
        } else {
            if (!appcan.isPlainObject(obj)) {
                return c;
            }
            for (var i in obj) {
                c++;
            }
            return c;
        }
    }

    /*
     *
     * 获取模版中的开始结束回调
     *
     * @param String k1 last: 或者 first:
     *
     */
    function getTempCallback(d, c, k1, k2, l) {
        var q = c.match(/(first:|last:)(\"|\'*)([^\"\']*)(\"|\'*)/);
        if (!q) {
            return;
        }
        if (q[1] == k1) {
            if (q[2] == '\"' || q[2] == '\'') {
                return q[3];
            } else {
                return d[q[3]];
            }
        } else if (q[1] == k2 && l > 1) {
            return "";
        }
    }

    /*
     *
     *
     *
     */

    function oldTemp(t, d, i, l, cb) {
        //匹配出 $｛内容｝
        return t.replace(/\$\{([^\}]*)\}/g, function(m, c) {
            if (c.match(/index:/)) {
                return i;
            }
            if (c.match(/cb:/) && cb) {
                return cb(d, c.match(/cb:(.*)/));
            }
            if (i == 0) {
                var s = getTempCallback(d, c, "first:", "last:", l);
                if (s) {
                    return s;
                }
            }
            if (i == (l - 1)) {
                var s = getTempCallback(d, c, "last:", "first:", l);
                if (s) {
                    return s;
                }
            }
            var ar = c.split('.');
            var res = d;
            for (var key in ar) {
                res = res[ar[key]];
            }
            return res || "";
        });
    };

    /*
     *
     * 根据指定的列表返回对应的数据
     *
     */
    var oldTempRenderList = function(t, dd, l, cb, scb) {
        var r = "";
        var index = 0;
        for (var i in dd) {
            if (scb) {
                scb(0, i, dd[i]);
            }
            var rr = oldTemp(t, dd[i], index, l, cb);
            if (scb) {
                scb(1, rr, dd[i]);
            }
            r += rr;
            index++;
        }
        return r;
    };
    /*
     *
     * 返回指定的数据
     *
     */
    function oldTempRender(t, dd, cb) {
        return oldTemp(t, dd, -1, -1, cb);
    }

    /*

     按顺序执行

     */
    function series(tasks, callback) {
        if (appcan.isFunction(tasks)) {
            callback = tasks;
            tasks = [];
        }
        callback = appcan.isFunction(callback) ? callback : function() {
        };
        var errData = 0;
        var resData = null;
        var taskIdx = 0;

        function nextTask() {
            if (taskIdx >= tasks.length) {
                callback(0);
                return;
            }
            var tsk = tasks[taskIdx];
            if (tsk && appcan.isFunction(tsk)) {
                try {
                    if (tsk(function(err, data) {
                        if (err === 0) {
                            taskIdx++;
                            nextTask();
                        } else {
                            //结束任务
                            callback(err, data);
                            return;
                        }
                    }) === false) {
                        //结束任务
                        callback(0);
                        return;
                    }
                } catch(e) {
                    callback(e);
                }
            }
        }

        nextTask();

    }

    //for emulator
    $(document).ready(function() {

    });

    initFontsize();

    module.exports = {
        elementFor : elementFor,
        touch : touch,
        initFontsize : initFontsize,
        openPopoverByEle : openPopoverByEle,
        resizePopoverByEle : appWin.resizePopoverByEle,
        tmpl : tmpl,
        tmplAppend : tmplAppend,
        openWinWithUrl : openWinWithUrl,
        closeWin : closeWin,
        closePopover : appWin.closePopover,
        setLocVal : setLocalVal,
        getLocVal : getLocalVal,
        execScriptInWin : execScriptInWin,
        bringPopoverToFront : appWin.bringPopoverToFront,
        initBounce : initBounce,
        evaluatePopoverScript : appWin.evaluatePopoverScript,
        alert : appWin.alert,
        getObjLength : objLength,
        getTempCallback : getTempCallback,
        temp : oldTemp,
        tempRenderList : oldTempRenderList,
        tempRender : oldTempRender,
        stopPropagation : stopPropagation,
        toInt : toInt,
        selectChange : selectChange,
        fold : fold,
        button : button,
        select : select,
        "switch" : switchBtn,
        switchBtn : switchBtn,
        series : series,
        updateSwitch : updateSwitch
    };
});

appcan.ready(function() {
    var ios7style = uexWidgetOne.iOS7Style;
    var isFullScreen = uexWidgetOne.isFullScreen;
    if (ios7style == '1' && isFullScreen != '1') {
        $("body").addClass("uh_ios7");
    }
});
/*
 *用到echarts时，在开发测试时安卓上可能出现问题，因此设置该值用来手动适配；
 * 正式打包，暂时不用，故设置为1.
 */
var midu;
/*测试时用到*/
    // midu = window.devicePixelRatio;
    // var plat = uexWidgetOne.getPlatform();
    // if (plat == 0) {
    // midu = 1;
    // }
    // if (midu>2) {
    // midu = 2.5;
    // };
    /*正规打包*/
    midu = 1;
Date.prototype.format = function(fmt) { 
     var o = { 
        "M+" : this.getMonth()+1,                 //月份 
        "d+" : this.getDate(),                    //日 
        "h+" : this.getHours(),                   //小时 
        "m+" : this.getMinutes(),                 //分 
        "s+" : this.getSeconds(),                 //秒 
        "q+" : Math.floor((this.getMonth()+3)/3), //季度 
        "S"  : this.getMilliseconds()             //毫秒 
    }; 
    if(/(y+)/.test(fmt)) {
            fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
    }
     for(var k in o) {
        if(new RegExp("("+ k +")").test(fmt)){
             fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
         }
     }
    return fmt; 
}
function setTimeChange(dateNum){
    var date;
    if(dateNum == undefined){
        date = date = new Date();
    }else {
        date = new Date(dateNum);
    }
    var YY = date.getFullYear();
    var MM = date.getMonth() + 1;
    var DD = date.getDate();
    var HH = date.getHours();
    var mm = date.getMinutes();
    var SS = date.getSeconds();
    if(MM < 10){
        MM = '0'+ MM;
    }
    if (DD < 10){
        DD = '0' + DD;
    }
    if(HH < 10){
        HH = '0'+HH;
    }
    if(mm < 10){
        mm = '0'+mm;
    }
    if(SS < 10){
        SS = '0'+SS;
    }
    return YY + '-' + MM + '-' + DD + ' ' + HH + ':' + mm + ':' + SS;
}
function massageflag(message)
{
     if(message=='401')
     {
          // 打开登录页面
          appcan.window.open('Login', 'Login.html', 10);
      }else
      {
                    // appcan.window.alert({
                        // title : "提示",
                        // content : message,
                        // buttons : "确定",
                    // });
                    appcan.window.openToast({
                                  msg:message,
                                  duration:1000*2,
                                  position:5,
                                  type:0
                            });
     }
}
function nowtime()
{
     var newDate = new Date();
        var currentYear = newDate.getFullYear();
        var currentMonth = newDate.getMonth() + 1;
        var currentDay = newDate.getDate();
        if (currentMonth < 10) {
            currentMonth = "0" + currentMonth;
        }
        //天数小于10时显示为'0X'
        if (currentDay < 10) {
            currentDay = "0" + currentDay;
        }
        var  startTime=currentYear+"-"+currentMonth+"-"+currentDay+" 00:00:00";
        return startTime;
}
//存入仓库数据
// var warehouselist=[{'id':'0','value':'ESP成品库'},
// {'id':'1','value':'edc仓库'}];
var warehouselist=[];

var floatObj = function () {

/*
* 判断obj是否为一个整数
*/
function isInteger(obj) {
return Math.floor(obj) === obj
}

/*
* 将一个浮点数转成整数，返回整数和倍数。如 3.14 >> 314，倍数是 100
* @param floatNum {number} 小数
* @return {object}
* {times:100, num: 314}
*/
function toInteger(floatNum) {
var ret = {times: 1, num: 0};
if (isInteger(floatNum)) {
ret.num = floatNum;
return ret
}
var strfi = floatNum + '';
var dotPos = strfi.indexOf('.');
var len = strfi.substr(dotPos + 1).length;
var times = Math.pow(10, len);
var intNum = parseInt(floatNum * times + 0.5, 10);
ret.times = times;
ret.num = intNum;
return ret
}

/*
* 核心方法，实现加减乘除运算，确保不丢失精度
* 思路：把小数放大为整数（乘），进行算术运算，再缩小为小数（除）
*
* @param a {number} 运算数1
* @param b {number} 运算数2
* @param op {string} 运算类型，有加减乘除（add/subtract/multiply/divide）
*
*/
function operation(a, b, op) {
var o1 = toInteger(a);
var o2 = toInteger(b);
var n1 = o1.num;
var n2 = o2.num;
var t1 = o1.times;
var t2 = o2.times;
var max = t1 > t2 ? t1 : t2;
var result = null;
switch (op) {
case 'add':
if (t1 === t2) { // 两个小数位数相同
result = n1 + n2
} else if (t1 > t2) { // o1 小数位 大于 o2
result = n1 + n2 * (t1 / t2)
} else { // o1 小数位 小于 o2
result = n1 * (t2 / t1) + n2
}
return result / max;
case 'subtract':
if (t1 === t2) {
result = n1 - n2
} else if (t1 > t2) {
result = n1 - n2 * (t1 / t2)
} else {
result = n1 * (t2 / t1) - n2
}
return result / max;
case 'multiply':
result = (n1 * n2) / (t1 * t2);
return result;
case 'divide':
result = (n1 / n2) * (t2 / t1);
return result
}
}

// 加减乘除的四个接口
function add(a, b) {
return operation(a, b, 'add')
}

function subtract(a, b) {
return operation(a, b, 'subtract')
}

function multiply(a, b) {
return operation(a, b, 'multiply')
}

function divide(a, b) {
return operation(a, b, 'divide')
}

// exports
return {
add: add,
subtract: subtract,
multiply: multiply,
divide: divide
}
}();

//把装上车的重量去掉
          /*console.log(floatObj.add(0.1, 0.2));//0.3
          console.log(floatObj.subtract(1.0, 0.9));//0.1
          console.log(floatObj.multiply(19.9, 100));//1990
          console.log(floatObj.divide(6.6, 0.2));//33*/
         

//弹出登录信息从新登录
function anewlogin(func)
{
    var userName=localStorage.getItem('USERID');
    var password=localStorage.getItem('PASSWORD');
    
    var IPAddress = localStorage.getItem("IPAddress");
    var obj=new Object();
    obj.userid=userName;
    obj.pwd=password;
    $.ajax({
        url:IPAddress+'login&sid='+localStorage.getItem("sessionid"),
        type:"POST",
        data:obj,
        timeout:1000,
        contentType:"application/x-www-form-urlencoded",
        dataType:"json",
        success: function(result) {
            //console.log(result.code);
            if (result.code=='1') {
                localStorage.setItem("sessionid",result.data.sessionid);
                func(result.code);
            } else {
                 //func('3');
                func(result.code);
            }
        },
        error : function(e) {
           func('0');
        }
    });
}
function tologin(){
    appcan.window.open({
           name:'Login',
           dataType:0,
           data:'Login.html'
        });
}
function tologin1(){
    appcan.window.open({
           name:'Login',
           dataType:0,
           data:'../Login.html'
        });
}
//点击     过快限制
var isClick = true;
function astrictclick(){
    if(isClick) {
      isClick = false;
      setTimeout(function() {
          isClick = true;
      },2*1000);//3秒内不能重复点击
    }else{
      alert('请勿过快点击需要停顿2秒');
      return "2";
    }
}
//点击过快限制不提醒
var isClick = true;
function astrictclick1(){
    if(isClick) {
      isClick = false;
      setTimeout(function() {
          isClick = true;
      },1*100);//3秒内不能重复点击
    }else{
      return "2";
    }
}
//扫码截取
function substrewm(ewm){
    var ewmarr=ewm.split(',');
    return ewmarr[0];
}
//转大写
$("#inputStation").keypress(function(event) {
            if ($(this).val().length < 7) {//限制输入字符串长度
                var key = event.which;//event.keyCode
                if (key >= 97 && key <= 122) {//找到输入是小写字母的ascII码的范围
                    event.preventDefault();//取消事件的默认行为
                    $(this).val($(this).val() + String.fromCharCode(key - 32));//转换
                }
            } else {
                if($(this).val().length==13)
                {
                    getinfo($(this).val());
                }else{
                    $(this).val($(this).val());    
                }
            }//控制长度
        });
        

//选中第一个多选框
function selfristcheck(){
    $(".box").each(function(index,domEle) {
        // console.log(index,domEle);
        if(index==0)
        $(this).prop('checked', true);
       
    });
}