/**
 * 页面公用整合js
 * 作者：周俊君
 * 创建时间：2018/06/20
 */
/**
 * 生成关键指标除顶部环状图展示部分数据
 */
function createMoreRealTime(sectionId, moreData, groupType) {
    $("#" + sectionId).html("");
    for (var i = 0; i < moreData.length; i++) {
        var hangItem;
        var imgClass;
        if (sectionId == "KeyMore") {
            if (i == 1) {
                groupType = "hao";
            } else {
                groupType = "gong";
            }
        }
        if (groupType == "gong") {
            imgClass = distinctImgClass(moreData[i].codeType);
        } else if (groupType == "hao") {
            imgClass = distinctConsumeImgClass(moreData[i].codeType);
        }
        if (i % 2 == 0) {
            hangItem = '<div class="ub ub-ac" style="margin:0.2em 0em">';
            hangItem += '<div style="width:50%">';
            hangItem += '<div class="ub ub-ver uinn5 uba diyDiv">';
            hangItem += '<div class="ub ub-ac"><div class="ub-img img-size ' + imgClass + '"></div><div class="ulev-m-22">' + moreData[i].name + '</div></div>';
            hangItem += '<div class="ub ub-pe ub-ac">' + createValue(moreData[i].value, moreData[i].unit) + '</div></div></div>';
            if (i == moreData.length - 1) {
                hangItem += '</div>';
                $("#" + sectionId).append(hangItem);
            };
        } else {
            hangItem += '<div style="width:50%">';
            hangItem += '<div class="ub ub-ver uinn5 uba diyDiv">';
            hangItem += '<div class="ub ub-ac"><div class="ub-img img-size ' + imgClass + '"></div><div class="ulev-m-22">' + moreData[i].name + '</div></div>';
            hangItem += '<div class="ub ub-pe ub-ac">' + createValue(moreData[i].value, moreData[i].unit) + '</div></div></div></div>';
            $("#" + sectionId).append(hangItem);
        };
    };
}

/**
 * 对数字进行处理
 * 整数位每三位加“，”；小数位字体变小
 */
function createValue(num, unit) {
    var integerStr = num.split(".")[0];
    var floatStr = num.split(".")[1];
    var integerStr = (integerStr || 0).toString(),
        result = '';
    // while (integerStr.length > 3) {
        // result = ',' + integerStr.slice(-3) + result;
        // integerStr = integerStr.slice(0, integerStr.length - 3);
    // }
    if (integerStr) {
        result = integerStr + result;
    }
    var endStr = '<span class="ulev-m-36">' + result + '</span>';
    if (num.indexOf(".") > -1) {
        endStr += '<span class="ulev-m-36">' + "." + '</span>';
        endStr += '<span class="ulev-m-30">' + floatStr + '</span>';
    };
    endStr += '<span class="ulev-m-26">' + unit + '</span>';
    return endStr;
}

/**
 *统一化单数据环状图设计
 */
function createHuanPie(echartId, name, value, color) {
    var other = 100 - Number(value);
    if (Number(value) > 100) {
        other = 0;
    };
    var huanOption = {
        title : {
            text : name,
            textStyle : {
                fontSize : 15 * midu,
                color : '#cccccc'
            },
            top : '5%',
            left : 'center'
        },
        series : [{
            name : '',
            type : 'pie',
            center : ['50%', '57%'],
            radius : ['65%', '70%'],
            avoidLabelOverlap : false,
            itemStyle : {
                normal : {
                    color : '#cccccc'
                }
            },
            labelLine : {
                normal : {
                    show : false
                }
            },
            silent : true,
            data : [{
                value : value,
                name : name,
                selected : false,
                label : {
                    normal : {
                        show : true,
                        position : 'center',
                        formatter : function(param) {
                            if (topId == "reliability") {
                                return value + '%';
                            } else {
                                return "平均\n" + value + '%';
                            }
                        },
                        textStyle : {
                            fontSize : 15 * midu,
                            fontWeight : 'bold',
                            color : '#cccccc'
                        }
                    },
                    emphasis : {
                        show : true,
                        textStyle : {
                            fontSize : 15 * midu,
                            fontWeight : 'bold'
                        }
                    }
                },
                itemStyle : {
                    normal : {
                        color : {
                            type : 'linear',
                            x : 0,
                            y : 0,
                            x2 : 0,
                            y2 : 0.6,
                            colorStops : [{
                                offset : 0,
                                color : color // 0% 处的颜色
                            }, {
                                offset : 0.6,
                                color : color // 100% 处的颜色
                            }],
                            globalCoord : true // 缺省为 false
                        }
                    }
                }
            }, {
                value : other,
                name : '其他',
                selected : false,
                label : {
                    normal : {
                        show : false
                    },
                    emphasis : {
                        show : false
                    }
                },
            }]
        }]
    }
    return huanOption;
}

/**
 *根据设备名称，区别设备的图片
 * @param {Object} deviceName
 */
function distinctDevice(deviceType, deviceStatus) {
    var pngName;
    var endName;
    if (Number(deviceType) == 1) {
        pngName = "weiranji";
    } else if (Number(deviceType) == 2) {
        pngName = "guolu";
    } else if (Number(deviceType) == 3) {
        pngName = "xiulengji";
    } else {
        pngName = "noDeviceImg";
        deviceStatus = "1";
    }
    // if (parseInt(deviceStatus) == 0) {
    // endName = pngName + "-stop";
    // }else{
    // endName = pngName;
    // }
    return "css/img/device_slices/" + pngName + "/" + pngName + "@2x.png";
}