/**
 * Created by ylt on 16/8/18.
 */
var uexFileMgrCase = {
    "create" : function() {
        var f = uexFileMgr.create({
            path : "wgt://create.txt"
        });
        if (f != null) {
            uexFileMgr.closeFile(f);
        }
    },
    "mkdir" : function() {
        uexFileMgr.deleteFileByPath("wgt://data/test11");
        var result = uexFileMgr.mkdir({
            path : "wgt://data/test11"
        });
    },
    "open" : function() {
        var f = uexFileMgr.open({
            path : "wgt://demo.txt",
            mode : 2
        });
        if (f != null) {
            uexFileMgr.closeFile(f);
            alert(true);
        } else {
            alert(false);
        }
    },
    "seekFile" : function() {
        var f = uexFileMgr.open({
            path : "wgt://seekDemo.txt",
            mode : 7
        });
        if (f != null) {
            uexFileMgr.writeFile(f, 0, "this is a case!this is a case!this is a case!this is a " + "case!this is a case!this is a case!this is a case!", function(ret) {
                var result = uexFileMgr.seekFile(f, 5);
                uexFileMgr.closeFile(f);
            })
        } else {
            alert(false);
        }
    },
    "seekBeginOfFile" : function() {
        var f = uexFileMgr.open({
            path : "wgt://seekDemo.txt",
            mode : 1
        });
        if (f != null) {
            var result = uexFileMgr.seekBeginOfFile(f);
            uexFileMgr.closeFile(f);
        } else {
            alert(false);
        }
    },
    "seekEndOfFile" : function() {
        var f = uexFileMgr.open({
            path : "wgt://seekDemo.txt",
            mode : 1
        });
        if (f != null) {
            var result = uexFileMgr.seekEndOfFile(f);
            uexFileMgr.closeFile(f);
        } else {
            alert(false);
        }
    },
    "deleteFileByPath" : function(filePath) {
            return uexFileMgr.deleteFileByPath(filePath);
    },
    "isFileExistByPath" : function() {
        var result = uexFileMgr.isFileExistByPath("wgt://data/222.txt");
    },
    "getFileTypeByPath" : function() {
        var result = uexFileMgr.getFileTypeByPath("wgt://data");
    },
    "writeFile" : function() {
        var f = uexFileMgr.open({
            path : "wgt://demo.txt",
            mode : 2
        });
        if (f != null) {
            uexFileMgr.writeFile(f, 0, "this is a case", function(error) {
                uexFileMgr.closeFile(f);
            })
        } else {
            alert(false);
        }
    },
    "readFile" : function() {
        var f = uexFileMgr.open({
            path : "wgt://demo.txt",
            mode : 2
        });
        if (f != null) {
            uexFileMgr.readFile(f, -1, 0, function(err, ret) {
                uexFileMgr.closeFile(f);
                alert(err + "--" + ret);
                if (!err)
                    alert(ret, "this is a case");
                else
                    alert(false);
            })
        } else
            alert(false);
    },
    "renameFile" : function() {
        uexFileMgr.renameFile({
            oldFilePath : "wgt://demo.txt",
            newFilePath : "wgt://open.txt"
        }, function(error) {
            alert(error);
        });
    },
    "getFileRealPath" : function(param,cb) {
        var p = uexFileMgr.getFileRealPath(param);
        cb(p);
    },
    "getFileSize" : function() {
        var file = uexFileMgr.open({
            path : "wgt://open.txt",
            mode : 3
        });
        var size = uexFileMgr.getFileSize(file, "wgt://open.txt");
        if (size != -1) {
            alert("size:" + size);
            alert(true);
        } else {
            alert(false);
        }
    },
    "getFilePath" : function() {
        var file = uexFileMgr.open({
            path : "wgt://data/1.txt",
            mode : 3
        });
        var path = uexFileMgr.getFilePath(file);
    },
    "closeFile" : function() {
        var file = uexFileMgr.open({
            path : "wgt://open.txt",
            mode : 3
        });
        if (file != null) {
            var result = uexFileMgr.closeFile(file);
        } else {
            alert(false);
        }
    },
    "getFileListByPath" : function() {
        var info = uexFileMgr.getFileListByPath("wgt://");
        alert(JSON.stringify(info));
    },
    "explorer" : function() {
        uexFileMgr.explorer("wgt://", function(error, path) {
            alert(JSON.stringify(path));
            if (!error) {
                alert(true);
            } else
                alert(false);
        })
    },
    "multiExplorer" : function() {
        uexFileMgr.multiExplorer("wgt://", function(error, path) {
            alert(JSON.stringify(path));
            if (!error) {
                alert(true);
            } else
                alert(false);
        })
    },
    "isFileExistByPath" : function(savePath) {
        return uexFileMgr.isFileExistByPath(savePath)
    },
    "createWithPassword" : function() {
        var file = uexFileMgr.createWithPassword({
            path : "wgt://data/123456.txt",
            password : "123456"
        });
        if (file != null) {
            alert(true);
        } else {
            alert(false);
        }
    },
    "openWithPassword" : function() {
        var file = uexFileMgr.openWithPassword({
            path : "wgt://data/123456.txt",
            password : "123456",
            mode : 3
        });
        if (!file) {
            alert(false);
        } else {
            alert(true);
        }
    },
    "search" : function() {
        var data = {
            path : "res://",
            flag : 5,
            keywords : ["case", "main"],
            suffixes : ["txt", "js"]
        };
        uexFileMgr.search(data, function(err, result) {
            if (!err) {
                alert(JSON.stringify(result));
                alert(true);
            } else {
                alert(false);
            }
        });
    },
    "getFileSizeByPath" : function() {
        var params = {
            path : "wgt://",
            unit : "KB"
        }
        uexFileMgr.getFileSizeByPath(params, function(error, info) {
            if (!error) {
                alert(JSON.stringify(info));
                alert(true);
            } else {
                alert(false);
            }
        });
    },
    "copy" : function() {
        uexFileMgr.copy({
            src : "res://test.zip",
            target : "wgt://data/"
        }, function(error) {
            if (!error) {
                alert(true);
            } else {
                alert(false);
            }
        });
    }
};
